;simple usage: gsi -e '(load "rrepl") (repl-server-start! "127.0.0.1" 44666) (thread-sleep! +inf.0)' >/dev/null 2>/dev/null &
;then try: telnet 127.0.0.1 44666

(define repl-server-start! #f)
(define repl-server-stop! #f)

(let* ((repl-server-thread #f)
       (tcp-server-port #f)
       (repl-server-proc 
        (lambda ()
         (let loop () 
           (let ((port (read tcp-server-port)))
                (thread-start!
                    (make-root-thread
                        (lambda ()
                            (##thread-repl-channel-set! 
                                (current-thread) 
                                (##make-repl-channel-ports port port))
                            (##with-no-result-expected
                                (lambda ()
                                      (##current-input-port 
                                        (##repl-input-port))
                                      (##current-output-port 
                                        (##repl-output-port))
                                      (##current-error-port 
                                        (##repl-output-port))
                                      (current-exception-handler 
                                         (lambda (exc)
                                          (##repl
                                           (lambda (first output-port)
                                               (##display-exception-in-context 
                                                    exc 
                                                    first 
                                                    output-port)
                                                #f)
                                           exc)))
                                      (##repl-debug #f  #t)))
                            (close-port port)))))
           (loop)))))

    (set! repl-server-start! 
        (lambda (#!optional (host "127.0.0.1") (port 6000))
            (set! tcp-server-port
                (open-tcp-server 
                  (list
                   server-address: host
                   port-number: port
                   backlog: 16
                   reuse-address: #t
                   coalesce: #f)))
            (set! repl-server-thread
                (make-thread repl-server-proc))
            (thread-start! repl-server-thread)))

    (set! repl-server-stop!
        (lambda ()
            (and repl-server-thread (thread-terminate! repl-server-thread))
            (set! repl-server-thread #f)
            (and tcp-server-port (close-port tcp-server-port))
            (set! tcp-server-port #f))))

(define (repl-client-start! host inet-port)
    (let ((port (open-tcp-client
    		     (list server-address: host
	    		   port-number:    inet-port
	    		   coalesce:       #f))))
        (thread-start!
            (make-root-thread
                (lambda ()
                    (##thread-repl-channel-set! 
                        (current-thread) 
                        (##make-repl-channel-ports port port))
                    (##with-no-result-expected
                        (lambda ()
                              (##current-input-port 
                                (##repl-input-port))
                              (##current-output-port 
                                (##repl-output-port))
                              (##current-error-port 
                                (##repl-output-port))
                              (current-exception-handler 
                                 (lambda (exc)
                                  (##repl
                                   (lambda (first output-port)
                                       (##display-exception-in-context 
                                            exc 
                                            first 
                                            output-port)
                                        #f)
                                   exc)))
                              (##repl-debug #f  #t)))
                    (close-port port))))))

;change this behavior according to your wishes
;(repl-server-start! "127.0.0.1" 44666)
;(thread-sleep! +inf.0)
